Index: cpukit/libmisc/monitor/README
===================================================================
--- cpukit/libmisc/monitor/README	(revision 637df35f96d8023056369fcf2c9943419f1a1b74)
+++ cpukit/libmisc/monitor/README	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -3,5 +3,95 @@
 #
 
-This is a snapshot of a work in process.  It is the beginnings of a
-debug monitor task and trap handler which is tasking aware.
+monitor task
 
+The monitor task is an optional task that knows about RTEMS
+data structures and can print out information about them.
+It is a work-in-progress and needs many more commands, but
+is useful now.
+
+The monitor works best when it is the highest priority task,
+so all your other tasks should ideally be at some priority
+greater than 1.
+
+To use the monitor:
+-------------------
+
+    #include <rtems/monitor.h>
+
+        ...
+
+    rtems_monitor_init(0);
+
+    The parameter to rtems_monitor_init() tells the monitor whether
+    to suspend itself on startup.  A value of 0 causes the monitor
+    to immediately enter command mode; a non-zero value causes the
+    monitor to suspend itself after creation and wait for explicit
+    wakeup.
+
+
+    rtems_monitor_wakeup();
+    
+    wakes up a suspended monitor and causes it to reenter command mode.
+
+Monitor commands
+----------------
+
+    The monitor prompt is 'rtems> '.
+    Can abbreviate commands to "uniquity"
+    There is a 'help' command.  Here is the output from various
+    help commands:
+
+        Commands (may be abbreviated)
+
+          help      -- get this message or command specific help
+          task      -- show task information
+          queue     -- show message queue information
+          symbol    -- show entries from symbol table
+          pause     -- pause monitor for a specified number of ticks
+          fatal     -- invoke a fatal RTEMS error
+
+        task [id [id ...] ]
+          display information about the specified tasks.
+          Default is to display information about all tasks on this node
+
+        queue [id [id ... ] ]
+          display information about the specified message queues
+          Default is to display information about all queues on this node
+
+        symbol [ symbolname [symbolname ... ] ]
+          display value associated with specified symbol.
+          Defaults to displaying all known symbols.
+
+        pause [ticks]
+          monitor goes to "sleep" for specified ticks (default is 1)
+          monitor will resume at end of period or if explicitly awakened
+
+        fatal [status]
+          Invoke 'rtems_fatal_error_occurred' with 'status'
+          (default is RTEMS_INTERNAL_ERROR)
+
+        continue
+          put the monitor to sleep waiting for an explicit wakeup from the
+          program running.
+
+
+Sample output from 'task' command
+---------------------------------
+
+    rtems> task
+      ID       NAME   PRIO   STAT   MODES  EVENTS   WAITID  WAITARG  NOTES
+    ------------------------------------------------------------------------
+    00010001   UI1     2    READY    P:T:nA    NONE15: 0x40606348
+    00010002   RMON    1    READY    nP    NONE15: 0x40604110
+
+    'RMON' is the monitor itself, so we have 1 "user" task.
+    Its modes are P:T:nA which translate to:
+
+        preemptable
+        timesliced
+        no ASRS
+
+    It has no events.
+    It has a notepad value for notepad 15 which is 0x40606348
+    (this is the libc thread state)
+
Index: cpukit/libmisc/monitor/mon-command.c
===================================================================
--- cpukit/libmisc/monitor/mon-command.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-command.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,190 @@
+/*
+ *	@(#)command.c	1.5 - 95/08/02
+ *	
+ *
+ * Command parsing routines for RTEMS monitor
+ *
+ * TODO:
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+
+#include "monitor.h"
+
+#include <stdio.h>
+#include <string.h>
+
+/*
+ * make_argv(cp): token-count
+ *	Break up the command line in 'cp' into global argv[] and argc (return
+ *	value).
+ */
+
+int
+rtems_monitor_make_argv(
+    char *cp,
+    int  *argc_p,
+    char **argv)
+{
+    int argc = 0;
+
+    while ((cp = strtok(cp, " \t\n\r")))
+    {
+	argv[argc++] = cp;
+	cp = (char *) NULL;
+    }
+    argv[argc] = (char *) NULL;			/* end of argv */
+
+    return *argc_p = argc;
+}
+
+
+/*
+ * Read and break up a monitor command
+ *
+ * We have to loop on the gets call, since it will return NULL under UNIX
+ *  RTEMS when we get a signal (eg: SIGALRM).
+ */
+
+int
+rtems_monitor_command_read(char *command,
+                           int  *argc,
+                           char **argv)
+{
+    extern rtems_configuration_table  BSP_Configuration;
+    static char monitor_prompt[32];
+    
+    /*
+     * put node number in the prompt if we are multiprocessing
+     */
+
+    if (BSP_Configuration.User_multiprocessing_table == 0)
+        sprintf(monitor_prompt, "%s", MONITOR_PROMPT);
+    else if (rtems_monitor_default_node != rtems_monitor_node)
+        sprintf(monitor_prompt, "%d-%s-%d", rtems_monitor_node, MONITOR_PROMPT, rtems_monitor_default_node);
+    else
+        sprintf(monitor_prompt, "%d-%s", rtems_monitor_node, MONITOR_PROMPT);
+
+#ifdef RTEMS_UNIX
+    /* RTEMS on unix gets so many interrupt system calls this is hosed */
+    printf("%s> ", monitor_prompt);
+    fflush(stdout);
+    while (gets(command) == (char *) 0)
+        ;
+#else
+    do
+    {
+        printf("%s> ", monitor_prompt);
+        fflush(stdout);
+    } while (gets(command) == (char *) 0);
+#endif
+
+    return rtems_monitor_make_argv(command, argc, argv);
+}
+
+/*
+ * Look up a command in a command table
+ *
+ */
+
+rtems_monitor_command_entry_t *
+rtems_monitor_command_lookup(
+    rtems_monitor_command_entry_t *table,
+    int                            argc,
+    char                          **argv
+)
+{
+    rtems_monitor_command_entry_t *p;
+    rtems_monitor_command_entry_t *abbreviated_match = 0;
+    int abbreviated_matches = 0;
+    char *command;
+    int command_length;
+
+    command = argv[0];
+
+    if ((table == 0) || (command == 0))
+        goto failed;
+    
+    command_length = strlen(command);
+
+    for (p = table; p->command; p++)
+        if (STREQ(command, p->command))    /* exact match */
+            goto done;
+        else if (STRNEQ(command, p->command, command_length))
+        {
+            abbreviated_matches++;
+            abbreviated_match = p;
+        }
+
+    /* no perfect match; is there a non-ambigous abbreviated match? */
+    if ( ! abbreviated_match)
+    {
+        printf("Unrecognized command '%s'; try 'help'\n", command);
+        goto failed;
+    }    
+
+    if (abbreviated_matches > 1)
+    {
+        printf("Command '%s' is ambiguous; try 'help'\n", command);
+        goto failed;
+    }
+    
+    p = abbreviated_match;
+
+done:
+    if (p->command_function == 0)
+        goto failed;
+    return p;
+
+failed:
+    return 0;
+}
+
+void
+rtems_monitor_command_usage(rtems_monitor_command_entry_t *table,
+                            char *command_string)
+{
+    rtems_monitor_command_entry_t *help = 0;
+    char *help_command_argv[2];
+    
+    /* if first entry in table is a usage, then print it out */
+    if (command_string == 0)
+    {        
+        if (STREQ(table->command, "--usage--") && table->usage)
+            help = table;
+    }
+    else
+    {
+        help_command_argv[0] = command_string;
+        help_command_argv[1] = 0;
+        help = rtems_monitor_command_lookup(table, 1, help_command_argv);
+    }
+
+    if (help)
+        printf("%s\n", help->usage);
+}
+
+
+void
+rtems_monitor_help_cmd(
+    int          argc,
+    char       **argv,
+    unsigned32   command_arg,
+    boolean verbose
+)
+{
+    int arg;
+    rtems_monitor_command_entry_t *command;
+
+    command = (rtems_monitor_command_entry_t *) command_arg;
+    
+    if (argc == 1)
+        rtems_monitor_command_usage(command, 0);
+    else
+    {
+        for (arg=1; argv[arg]; arg++)
+            rtems_monitor_command_usage(command, argv[arg]);
+    }
+}
Index: cpukit/libmisc/monitor/mon-config.c
===================================================================
--- cpukit/libmisc/monitor/mon-config.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-config.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,132 @@
+/*
+ *	@(#)config.c	1.5 - 95/08/02
+ *	
+ *
+ * RTEMS Config display support
+ *
+ * TODO
+ *
+ *  $Id$
+ */
+
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+#include <stdlib.h>             /* strtoul() */
+
+#define DATACOL 15
+#define CONTCOL DATACOL		/* continued col */
+
+/*
+ * Fill in entire monitor config table
+ * for sending to a remote monitor or printing on the local system
+ */
+
+void
+rtems_monitor_config_canonical(
+    rtems_monitor_config_t *canonical_config,
+    void                   *config_void
+)
+{
+    rtems_configuration_table *c = (rtems_configuration_table *) config_void;
+
+    canonical_config->work_space_start = c->work_space_start;
+    canonical_config->work_space_size = c->work_space_size;
+    canonical_config->maximum_tasks = c->maximum_tasks;
+    canonical_config->maximum_timers = c->maximum_timers;
+    canonical_config->maximum_semaphores = c->maximum_semaphores;
+    canonical_config->maximum_message_queues = c->maximum_message_queues;
+    canonical_config->maximum_partitions = c->maximum_partitions;
+    canonical_config->maximum_regions = c->maximum_regions;
+    canonical_config->maximum_ports = c->maximum_ports;
+    canonical_config->maximum_periods = c->maximum_periods;
+    canonical_config->maximum_extensions = c->maximum_extensions;
+    canonical_config->microseconds_per_tick = c->microseconds_per_tick;
+    canonical_config->ticks_per_timeslice = c->ticks_per_timeslice;
+    canonical_config->number_of_initialization_tasks = c->number_of_initialization_tasks;
+}    
+
+/*
+ * This is easy, since there is only 1 (altho we could get them from
+ *    other nodes...)
+ */
+
+void *
+rtems_monitor_config_next(
+    void                  *object_info,
+    rtems_monitor_config_t *canonical_config,
+    rtems_id              *next_id
+)
+{
+    rtems_configuration_table *c = _Configuration_Table;
+    int n = rtems_get_index(*next_id);
+
+    if (n >= 1)
+        goto failed;
+    
+    _Thread_Disable_dispatch();
+
+    *next_id += 1;
+    return (void *) c;
+
+failed:
+    *next_id = RTEMS_OBJECT_ID_FINAL;
+    return 0;
+}
+
+
+void
+rtems_monitor_config_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+INITIAL (startup) Configuration Info\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+    rtems_monitor_separator();
+}
+
+
+void
+rtems_monitor_config_dump(
+    rtems_monitor_config_t *monitor_config,
+    boolean                 verbose
+)
+{
+    unsigned32   length = 0;
+
+    length = 0;
+    length += printf("WORKSPACE");
+    length += rtems_monitor_pad(DATACOL, length);
+    length += printf("start: 0x%x;  size: 0x%x\n",
+                     (unsigned32) monitor_config->work_space_start,
+                     monitor_config->work_space_size);
+
+    length = 0;
+    length += printf("TIME");
+    length += rtems_monitor_pad(DATACOL, length);
+    length += printf("usec/tick: %d;  tick/timeslice: %d;  tick/sec: %d\n",
+                     monitor_config->microseconds_per_tick,
+                     monitor_config->ticks_per_timeslice,
+                     1000000 / monitor_config->microseconds_per_tick);
+
+    length = 0;
+    length += printf("MAXIMUMS");
+    length += rtems_monitor_pad(DATACOL, length);
+    length += printf("tasks: %d;  timers: %d;  sems: %d;  que's: %d;  ext's: %d\n",
+                     monitor_config->maximum_tasks,
+                     monitor_config->maximum_timers,
+                     monitor_config->maximum_semaphores,
+                     monitor_config->maximum_message_queues,
+                     monitor_config->maximum_extensions);
+    length = 0;
+    length += rtems_monitor_pad(CONTCOL, length);
+    length += printf("partitions: %d;  regions: %d;  ports: %d;  periods: %d\n",
+                     monitor_config->maximum_partitions,
+                     monitor_config->maximum_regions,
+                     monitor_config->maximum_ports,
+                     monitor_config->maximum_periods);
+}
Index: cpukit/libmisc/monitor/mon-dname.c
===================================================================
--- cpukit/libmisc/monitor/mon-dname.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-dname.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,113 @@
+/*
+ *	@(#)dname.c	1.3 - 95/07/31
+ *	
+ *
+ * RTEMS monitor driver names support.
+ *
+ * There are 2 "driver" things the monitor knows about.
+ *
+ *    1. Regular RTEMS drivers.
+ *         This is a table indexed by major device number and
+ *         containing driver entry points only.
+ *
+ *    2. Driver name table.
+ *         A separate table of names for drivers.
+ *         The table converts driver names to a major number
+ *         as index into the driver table and a minor number
+ *         for an argument to driver.
+ *
+ *  Drivers are displayed with 'driver' command.
+ *  Names are displayed with 'dname' command.
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+
+#include "monitor.h"
+
+#include <stdio.h>
+#include <stdlib.h>             /* strtoul() */
+#include <string.h>		/* strncpy() */
+
+#define DATACOL 15
+#define CONTCOL DATACOL		/* continued col */
+
+void
+rtems_monitor_dname_canonical(
+    rtems_monitor_dname_t  *canonical_dname,
+    void                  *dname_void
+)
+{
+    rtems_driver_name_t    *np = (rtems_driver_name_t *) dname_void;
+
+    (void) strncpy(canonical_dname->name_string, np->device_name, sizeof(canonical_dname->name_string));
+    canonical_dname->major = np->major;
+    canonical_dname->minor = np->minor;
+}    
+
+void *
+rtems_monitor_dname_next(
+    void                   *object_information,
+    rtems_monitor_dname_t  *canonical_dname,
+    rtems_id               *next_id
+)
+{
+    int n = rtems_get_index(*next_id);
+    rtems_driver_name_t    *table = object_information;
+    rtems_driver_name_t    *np = 0;
+
+    for (np = table + n ; n<RTEMS_MAX_DRIVER_NAMES; n++, np++)
+        if (np->device_name)
+            goto done;
+    
+    *next_id = RTEMS_OBJECT_ID_FINAL;
+    return 0;
+
+done:
+    _Thread_Disable_dispatch();
+
+    /*
+     * dummy up a fake id and name for this item
+     */
+
+    canonical_dname->id = n;
+    canonical_dname->name = rtems_build_name('-', '-', '-', '-');
+
+    *next_id += 1;
+    return np;
+}    
+
+void
+rtems_monitor_dname_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+  Major:Minor   Name\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+    rtems_monitor_separator();
+}
+
+void
+rtems_monitor_dname_dump(
+    rtems_monitor_dname_t *monitor_dname,
+    boolean                 verbose
+)
+{
+    unsigned32             length = 0;
+
+    length += rtems_monitor_pad(6, length);
+    length += rtems_monitor_dump_hex(monitor_dname->major);
+    length += printf(":");
+    length += rtems_monitor_dump_hex(monitor_dname->minor);
+
+    length += rtems_monitor_pad(16, length);
+    length += printf("%.*s",
+                     (int) sizeof(monitor_dname->name_string),
+                     (char *) monitor_dname->name_string);
+
+    length += printf("\n");
+    length = 0;
+}
Index: cpukit/libmisc/monitor/mon-driver.c
===================================================================
--- cpukit/libmisc/monitor/mon-driver.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-driver.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,138 @@
+/*
+ *	@(#)driver.c	1.4 - 95/08/02
+ *	
+ *
+ * RTEMS monitor IO (device drivers) support
+ *
+ * There are 2 "driver" things the monitor knows about.
+ *
+ *    1. Regular RTEMS drivers.
+ *         This is a table indexed by major device number and
+ *         containing driver entry points only.
+ *
+ *    2. Driver name table.
+ *         A separate table of names for drivers.
+ *         The table converts driver names to a major number
+ *         as index into the driver table and a minor number
+ *         for an argument to driver.
+ *
+ *  Drivers are displayed with 'driver' command.
+ *  Names are displayed with 'name' command.
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+
+#include "monitor.h"
+
+#include <stdio.h>
+#include <stdlib.h>             /* strtoul() */
+
+#define DATACOL 15
+#define CONTCOL DATACOL		/* continued col */
+
+
+void
+rtems_monitor_driver_canonical(
+    rtems_monitor_driver_t *canonical_driver,
+    void                   *driver_void
+)
+{
+    rtems_driver_address_table *d = (rtems_driver_address_table *) driver_void;
+
+    rtems_monitor_symbol_canonical_by_value(&canonical_driver->initialization,
+                                            d->initialization);
+
+    rtems_monitor_symbol_canonical_by_value(&canonical_driver->open,
+                                            d->open);
+    rtems_monitor_symbol_canonical_by_value(&canonical_driver->close,
+                                            d->close);
+    rtems_monitor_symbol_canonical_by_value(&canonical_driver->read,
+                                            d->read);
+    rtems_monitor_symbol_canonical_by_value(&canonical_driver->write,
+                                            d->write);
+    rtems_monitor_symbol_canonical_by_value(&canonical_driver->control,
+                                            d->control);
+}
+
+
+void *
+rtems_monitor_driver_next(
+    void                  *object_info,
+    rtems_monitor_driver_t *canonical_driver,
+    rtems_id              *next_id
+)
+{
+    rtems_configuration_table *c = _Configuration_Table;
+    int n = rtems_get_index(*next_id);
+
+    if (n >= c->number_of_device_drivers)
+        goto failed;
+    
+    _Thread_Disable_dispatch();
+
+    /*
+     * dummy up a fake id and name for this item
+     */
+
+    canonical_driver->id = n;
+    canonical_driver->name = rtems_build_name('-', '-', '-', '-');
+
+    *next_id += 1;
+    return (void *) (c->Device_driver_table + n);
+
+failed:
+    *next_id = RTEMS_OBJECT_ID_FINAL;
+    return 0;
+}
+
+
+void
+rtems_monitor_driver_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+  Major      Entry points\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+    rtems_monitor_separator();
+}
+
+void
+rtems_monitor_driver_dump(
+    rtems_monitor_driver_t *monitor_driver,
+    boolean                 verbose
+)
+{
+    unsigned32          length = 0;
+
+    length += printf("  %d", monitor_driver->id);
+
+    length += rtems_monitor_pad(13, length);
+    length += printf("init: ");
+    length += rtems_monitor_symbol_dump(&monitor_driver->initialization, verbose);
+    length += printf(";  control: ");
+    length += rtems_monitor_symbol_dump(&monitor_driver->control, verbose);
+    length += printf("\n");
+    length = 0;
+
+    length += rtems_monitor_pad(13, length);
+
+    length += printf("open: ");
+    length += rtems_monitor_symbol_dump(&monitor_driver->open, verbose);
+    length += printf(";  close: ");
+    length += rtems_monitor_symbol_dump(&monitor_driver->close, verbose);
+    length += printf("\n");
+    length = 0;
+
+    length += rtems_monitor_pad(13, length);
+
+    length += printf("read: ");
+    length += rtems_monitor_symbol_dump(&monitor_driver->read, verbose);
+    length += printf(";  write: ");
+    length += rtems_monitor_symbol_dump(&monitor_driver->write, verbose);
+    length += printf("\n");
+    length = 0;
+}
Index: cpukit/libmisc/monitor/mon-extension.c
===================================================================
--- cpukit/libmisc/monitor/mon-extension.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-extension.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,101 @@
+/*
+ *	@(#)extension.c	1.3 - 95/07/31
+ *	
+ *
+ * RTEMS Monitor extension support
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+
+void
+rtems_monitor_extension_canonical(
+    rtems_monitor_extension_t *canonical_extension,
+    void                  *extension_void
+)
+{
+    Extension_Control     *rtems_extension = (Extension_Control *) extension_void;
+    rtems_extensions_table *e = &rtems_extension->Extension.Callouts;
+
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->create,
+                                            e->rtems_task_create);
+
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->start,
+                                            e->rtems_task_start);
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->restart,
+                                            e->rtems_task_restart);
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->delete,
+                                            e->rtems_task_delete);
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->tswitch,
+                                            e->task_switch);
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->begin,
+                                            e->task_begin);
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->exitted,
+                                            e->task_exitted);
+    rtems_monitor_symbol_canonical_by_value(&canonical_extension->fatal,
+                                            e->fatal);
+}
+
+void
+rtems_monitor_extension_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+  ID       NAME\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+           
+    rtems_monitor_separator();
+}
+
+
+/*
+ * Dump out the canonical form
+ */
+
+void
+rtems_monitor_extension_dump(
+    rtems_monitor_extension_t *monitor_extension,
+    boolean  verbose
+)
+{
+    unsigned32           length = 0;
+
+    length += rtems_monitor_dump_id(monitor_extension->id);
+    length += rtems_monitor_pad(11, length);
+    length += rtems_monitor_dump_name(monitor_extension->name);
+
+    length += rtems_monitor_pad(18, length);
+    length += printf("create: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->create, verbose);
+    length += printf(";  start: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->start, verbose);
+    length += printf(";  restart: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->restart, verbose);
+    length += printf("\n");
+    length = 0;
+
+    length += rtems_monitor_pad(18, length);
+    length += printf("delete: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->delete, verbose);
+    length += printf(";  switch: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->tswitch, verbose);
+    length += printf(";  begin: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->begin, verbose);
+    length += printf("\n");
+    length = 0;
+
+    length += rtems_monitor_pad(18, length);
+    length += printf("exitted: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->exitted, verbose);
+    length += printf(";  fatal: ");
+    length += rtems_monitor_symbol_dump(&monitor_extension->fatal, verbose);
+    length += printf("\n");
+    length = 0;
+    printf("\n");
+}
Index: cpukit/libmisc/monitor/mon-itask.c
===================================================================
--- cpukit/libmisc/monitor/mon-itask.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-itask.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,117 @@
+/*
+ *	@(#)itask.c	1.4 - 95/08/02
+ *	
+ *
+ * RTEMS Monitor init task support
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+
+/*
+ * As above, but just for init tasks
+ */
+void
+rtems_monitor_init_task_canonical(
+    rtems_monitor_init_task_t *canonical_itask,
+    void                  *itask_void
+)
+{
+    rtems_initialization_tasks_table *rtems_itask = itask_void;
+    
+    rtems_monitor_symbol_canonical_by_value(&canonical_itask->entry,
+                                            rtems_itask->entry_point);
+
+    canonical_itask->argument = rtems_itask->argument;
+    canonical_itask->stack_size = rtems_itask->stack_size;
+    canonical_itask->priority = rtems_itask->initial_priority;
+    canonical_itask->modes = rtems_itask->mode_set;
+    canonical_itask->attributes = rtems_itask->attribute_set;
+}
+
+void *
+rtems_monitor_init_task_next(
+    void                  *object_info,
+    rtems_monitor_init_task_t *canonical_init_task,
+    rtems_id              *next_id
+)
+{
+    rtems_configuration_table *c = _Configuration_Table;
+    rtems_initialization_tasks_table *itask;
+    int n = rtems_get_index(*next_id);
+
+    if (n >= c->number_of_initialization_tasks)
+        goto failed;
+    
+    _Thread_Disable_dispatch();
+
+    itask = c->User_initialization_tasks_table + n;
+
+    /*
+     * dummy up a fake id and name for this item
+     */
+
+    canonical_init_task->id = n;
+    canonical_init_task->name = itask->name;
+
+    *next_id += 1;
+    return (void *) itask;
+
+failed:
+    *next_id = RTEMS_OBJECT_ID_FINAL;
+    return 0;
+}
+
+
+void
+rtems_monitor_init_task_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+  #    NAME   ENTRY        ARGUMENT    PRIO   MODES  ATTRIBUTES   STACK SIZE\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+    rtems_monitor_separator();
+}
+
+/*
+ */
+
+void
+rtems_monitor_init_task_dump(
+    rtems_monitor_init_task_t *monitor_itask,
+    boolean  verbose
+)
+{
+    int length = 0;
+
+    length += rtems_monitor_dump_decimal(monitor_itask->id);
+
+    length += rtems_monitor_pad(7, length);
+    length += rtems_monitor_dump_name(monitor_itask->name);
+
+    length += rtems_monitor_pad(14, length);
+    length += rtems_monitor_symbol_dump(&monitor_itask->entry, verbose);
+
+    length += rtems_monitor_pad(25, length);
+    length += printf("%d [0x%x]", monitor_itask->argument, monitor_itask->argument);
+
+    length += rtems_monitor_pad(39, length);
+    length += rtems_monitor_dump_priority(monitor_itask->priority);
+
+    length += rtems_monitor_pad(46, length);
+    length += rtems_monitor_dump_modes(monitor_itask->modes);
+
+    length += rtems_monitor_pad(54, length);
+    length += rtems_monitor_dump_attributes(monitor_itask->attributes);
+    
+    length += rtems_monitor_pad(66, length);
+    length += printf("%d [0x%x]", monitor_itask->stack_size, monitor_itask->stack_size);
+
+    printf("\n");
+}
Index: cpukit/libmisc/monitor/mon-manager.c
===================================================================
--- cpukit/libmisc/monitor/mon-manager.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-manager.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,52 @@
+/*
+ *	@(#)manager.c	1.2 - 95/07/31
+ *	
+ *
+ * RTEMS Monitor "manager" support.
+ * Used to traverse object (chain) lists and print them out.
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+
+#include <monitor.h>
+
+/*
+ * "next" routine for all objects that are RTEMS manager objects
+ */
+
+void *
+rtems_monitor_manager_next(
+    void      *table_void,
+    void      *canonical,
+    rtems_id  *next_id
+)
+{
+    Objects_Information     *table = table_void;
+    rtems_monitor_generic_t *copy;
+    Objects_Control         *object = 0;
+    unsigned32               location;
+
+    /*
+     * When we are called, it must be local
+     */
+       
+    if ( ! _Objects_Is_local_id(*next_id))
+        goto done;
+    
+    object = _Objects_Get_next(table, *next_id, &location, next_id);
+
+    if (object)
+    {
+        copy = (rtems_monitor_generic_t *) canonical;
+        copy->id = object->id;
+        copy->name = table->name_table[rtems_get_index(copy->id)];
+    }    
+    
+done:
+    return object;
+}
+
